%define major		0
%define libname		%mklibname %{name} %{major}
%define develname	%mklibname %{name} -d

%define mocklibname	%mklibname gmock %{major}
%define mockdevelname	%mklibname gmock -d

Name:		gtest
Summary:	Google's framework for writing C++ tests
Version:	1.10.0
Release:	%mkrel 1
License:	BSD
Group:		System/Libraries
URL:		https://github.com/google/googletest
Source0:	https://github.com/google/googletest/archive/release-%{version}.tar.gz
Patch0:		gtest-PR2491-Fix-gnu-install-dirs-pkg-config.patch
Patch1:		gtest-PR2556-pkg-config-Remove-pthread-link-flag-from-Cflags.patch
Patch100:	gtest-1.8.1-soname.patch
Patch101:	gtest-1.10.0-add-missing-pkgconfig-requires.patch
Patch102:	%{name}-gcc11.patch
BuildRequires:	python3-devel
BuildRequires:	cmake

%description
Google's framework for writing C++ tests on a variety of platforms
(Linux, Mac OS X, Windows, Cygwin, Windows CE, and Symbian). Based
on the xUnit architecture. Supports automatic test discovery, a rich
set of assertions, user-defined assertions, death tests, fatal and
non-fatal failures, value- and type-parameterized tests, various
options for running the tests, and XML test report generation.

%package -n %{libname}
Summary:	Shared libraries for %{name}
Group:		System/Libraries

%description -n %{libname}
Google's framework for writing C++ tests on a variety of platforms
(Linux, Mac OS X, Windows, Cygwin, Windows CE, and Symbian). Based
on the xUnit architecture. Supports automatic test discovery, a rich
set of assertions, user-defined assertions, death tests, fatal and
non-fatal failures, value- and type-parameterized tests, various
options for running the tests, and XML test report generation.

This package contains the shared %{name} libraries.

%package -n %{develname}
Summary:	Development files for %{name}
Group:		Development/Libraries
Requires:	%{libname} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}

%description -n	%{develname}
This package contains development files for %{name}.

%package -n	%{mocklibname}
Summary:	Shared libraries for gmock
Group:		System/Libraries

%description -n	%{mocklibname}
Inspired by jMock, EasyMock, and Hamcrest, and designed with C++'s
specifics in mind, Google C++ Mocking Framework (or Google Mock for
short) is a library for writing and using C++ mock classes.

Google Mock:

 o lets you create mock classes trivially using simple macros,
 o supports a rich set of matchers and actions,
 o handles unordered, partially ordered, or completely ordered
   expectations,
 o is extensible by users, and
 o works on Linux, Mac OS X, Windows, Windows Mobile, minGW, and
   Symbian.

%package -n %{mockdevelname}
Summary:	Development files for gmock
Group:		Development/Libraries
Requires:	%{mocklibname} = %{version}-%{release}
Provides:	gmock-devel = %{version}-%{release}

%description -n	%{mockdevelname}
This package contains development files for gmock.

%prep
%setup -qn googletest-release-%{version}
%apply_patches

# Set the version correctly
sed -e "s/set(GOOGLETEST_VERSION .*)/set(GOOGLETEST_VERSION %{version})/" -i CMakeLists.txt

%build
%cmake \
	-Dgtest_build_tests=ON \
	-DPYTHON_EXECUTABLE=%{__python3} \
	-Dgtest_build_samples=ON
%make_build

%install
%cmake_install

pushd googletest
  install -d %{buildroot}%{_usrsrc}/gtest/src
  install -p -m 644 src/* %{buildroot}%{_usrsrc}/gtest/src
popd

pushd googlemock
  install -d %{buildroot}%{_usrsrc}/gmock/src
  install -p -m 644 src/* %{buildroot}%{_usrsrc}/gmock/src
popd

%files -n %{libname}
%{_libdir}/lib%{name}*.so.%{major}*

%files -n %{develname}
%{_libdir}/lib%{name}*.so
%{_libdir}/pkgconfig/%{name}*.pc
%{_libdir}/cmake/GTest/
%{_includedir}/%{name}/
%{_usrsrc}/%{name}/

%files -n %{mocklibname}
%{_libdir}/libgmock*.so.%{major}*

%files -n %{mockdevelname}
%{_libdir}/libgmock*.so
%{_libdir}/pkgconfig/gmock*.pc
%{_includedir}/gmock/
%{_usrsrc}/gmock/


%changelog
* Sun Mar 07 2021 pp 1.10.0-1pclos2021
- update

* Sun Nov 17 2019 tex - 1.8.1-2pclos2019
- rebuild against updates

* Mon Jan 27 2019 tex 1.8.1-1pclos2019
- new
